/* mail.c 
 *
 * opens a mail-spoolfile and counts mail
 *
 * this code is part of the xled program
 *
 * Copyright 1997 Jan Schoenepauck & Joachim Gassen 
 * aka Fast Forward Productions
 *
 * check out http://fb4-1112.uni-muenster.de/ffwd
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#define BUFFER_SIZE 1024

extern void close_all (int);
extern char *myname;

int count_occurences (FILE *file, char *exp) {
  char buf[BUFFER_SIZE];
  int len, matches = 0;
  len = strlen(exp);	
  while (fgets(buf, BUFFER_SIZE, file)) {
    if (!strncmp(buf, exp, len)) 
      matches++;
  }
  rewind(file);
  return (matches);
}

FILE * open_mailbox_file (char * file) {
  FILE * mailbox;    
  if ( (mailbox = fopen(file, "r")) == NULL ) {
    fprintf(stderr,"%s: Error opening mailbox: %s\n", myname, strerror(errno));
    close_all(-1);
  }
  return (mailbox);
}

/* counts mail in spool-file 
 * if "all" is set, all mails are count otherwise only the unread ones
 * should be conform to smtp
 * if not - please let us know!
 */

int count_mail (char *file, int all) {
  int From, Status;
  FILE *F;
  F=open_mailbox_file (file);
  From = count_occurences(F, "From ");
  Status = count_occurences(F, "Status: R");
  fclose (F);
  return (all?From:(From - Status));
}













































